
	/*!
  * tiptap v0.1.4
  * (c) 2018 Scrumpy UG (limited liability)
  * @license MIT
  */

(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prosemirror-commands'), require('prosemirror-history'), require('prosemirror-inputrules'), require('vue'), require('prosemirror-utils'), require('prosemirror-state'), require('prosemirror-keymap'), require('prosemirror-schema-list')) :
	typeof define === 'function' && define.amd ? define(['exports', 'prosemirror-commands', 'prosemirror-history', 'prosemirror-inputrules', 'vue', 'prosemirror-utils', 'prosemirror-state', 'prosemirror-keymap', 'prosemirror-schema-list'], factory) :
	(factory((global.tiptap = {}),global.prosemirrorCommands,global.prosemirrorHistory,global.prosemirrorInputrules,global.Vue,global.prosemirrorUtils,global.prosemirrorState,global.prosemirrorKeymap,global.prosemirrorSchemaList));
}(this, (function (exports,prosemirrorCommands,prosemirrorHistory,prosemirrorInputrules,Vue,prosemirrorUtils,prosemirrorState,prosemirrorKeymap,prosemirrorSchemaList) { 'use strict';

	Vue = Vue && Vue.hasOwnProperty('default') ? Vue['default'] : Vue;

	function removeMark (type) {
	  return function (state, dispatch) {
			var ref = state.selection;
			var from = ref.from;
			var to = ref.to;
			return dispatch(state.tr.removeMark(from, to, type))
		}
	}

	typeof navigator !== 'undefined' ? /Mac/.test(navigator.platform) : false;

	function nodeIsActive (state, type, attrs) {
		var predicate = function (node) { return node.type === type; };
		var parent = prosemirrorUtils.findParentNode(predicate)(state.selection);

		if (attrs === {} || !parent) {
			return !!parent
		}

		return parent.node.hasMarkup(type, attrs)
	}

	var Node = function Node(options) {
		if ( options === void 0 ) options = {};

		this.options = Object.assign({}, this.defaultOptions,
			options);
	};

	var prototypeAccessors = { name: { configurable: true },defaultOptions: { configurable: true },type: { configurable: true },view: { configurable: true },schema: { configurable: true },plugins: { configurable: true } };

	prototypeAccessors.name.get = function () {
		return null
	};

	prototypeAccessors.defaultOptions.get = function () {
		return {}
	};

	prototypeAccessors.type.get = function () {
		return 'node'
	};

	prototypeAccessors.view.get = function () {
		return null
	};

	prototypeAccessors.schema.get = function () {
		return null
	};

	prototypeAccessors.plugins.get = function () {
		return []
	};

	Node.prototype.command = function command () {
		return function () {}
	};

	Node.prototype.keys = function keys () {
		return {}
	};

	Node.prototype.inputRules = function inputRules () {
		return []
	};

	Object.defineProperties( Node.prototype, prototypeAccessors );

	var Mark = function Mark(options) {
		if ( options === void 0 ) options = {};

		this.options = Object.assign({}, this.defaultOptions,
			options);
	};

	var prototypeAccessors$1 = { name: { configurable: true },defaultOptions: { configurable: true },type: { configurable: true },view: { configurable: true },schema: { configurable: true },plugins: { configurable: true } };

	prototypeAccessors$1.name.get = function () {
		return null
	};

	prototypeAccessors$1.defaultOptions.get = function () {
		return {}
	};

	prototypeAccessors$1.type.get = function () {
		return 'mark'
	};

	prototypeAccessors$1.view.get = function () {
		return null
	};

	prototypeAccessors$1.schema.get = function () {
		return null
	};

	prototypeAccessors$1.plugins.get = function () {
		return []
	};

	Mark.prototype.command = function command () {
		return function () {}
	};

	Mark.prototype.keys = function keys () {
		return {}
	};

	Mark.prototype.inputRules = function inputRules () {
		return []
	};

	Object.defineProperties( Mark.prototype, prototypeAccessors$1 );

	var PluginManager = function PluginManager(plugins) {
		if ( plugins === void 0 ) plugins = [];

		this.plugins = plugins;
	};

	var prototypeAccessors$2 = { nodes: { configurable: true },marks: { configurable: true },pluginplugins: { configurable: true },views: { configurable: true } };

	prototypeAccessors$2.nodes.get = function () {
		return this.plugins
			.filter(function (plugin) { return plugin.type === 'node'; })
			.reduce(function (nodes, ref) {
					var obj;

					var name = ref.name;
					var schema = ref.schema;
					return (Object.assign({}, nodes,
				( obj = {}, obj[name] = schema, obj )));
			}, {})
	};

	prototypeAccessors$2.marks.get = function () {
		return this.plugins
			.filter(function (plugin) { return plugin.type === 'mark'; })
			.reduce(function (marks, ref) {
					var obj;

					var name = ref.name;
					var schema = ref.schema;
					return (Object.assign({}, marks,
				( obj = {}, obj[name] = schema, obj )));
			}, {})
	};

	prototypeAccessors$2.pluginplugins.get = function () {
		return this.plugins
			.filter(function (plugin) { return plugin.plugins; })
			.reduce(function (allPlugins, ref) {
					var plugins = ref.plugins;

					return (allPlugins.concat( plugins ));
			}, [])
	};

	prototypeAccessors$2.views.get = function () {
		return this.plugins
			.filter(function (plugin) { return plugin.view; })
			.reduce(function (views, ref) {
					var obj;

					var name = ref.name;
					var view = ref.view;
					return (Object.assign({}, views,
				( obj = {}, obj[name] = view, obj )));
			}, {})
	};

	PluginManager.prototype.keymaps = function keymaps (ref) {
			var schema = ref.schema;

		return this.plugins
			.filter(function (plugin) { return plugin.keys; })
			.map(function (plugin) { return plugin.keys({
				type: schema[((plugin.type) + "s")][plugin.name],
				schema: schema,
			}); })
			.map(function (keys) { return prosemirrorKeymap.keymap(keys); })
	};

	PluginManager.prototype.inputRules = function inputRules (ref) {
			var schema = ref.schema;

		return this.plugins
			.filter(function (plugin) { return plugin.inputRules; })
			.map(function (plugin) { return plugin.inputRules({
				type: schema[((plugin.type) + "s")][plugin.name],
				schema: schema,
			}); })
			.reduce(function (allInputRules, inputRules) { return (allInputRules.concat( inputRules )); }, [])
	};

	PluginManager.prototype.commands = function commands (ref) {
			var schema = ref.schema;
			var view = ref.view;

		return this.plugins
			.filter(function (plugin) { return plugin.command; })
			.reduce(function (commands, ref) {
					var obj;

					var name = ref.name;
					var type = ref.type;
					var command = ref.command;
					return (Object.assign({}, commands,
				( obj = {}, obj[name] = function (attrs) {
					view.focus();
					command({
						type: schema[(type + "s")][name],
						attrs: attrs,
						schema: schema,
					})(view.state, view.dispatch, view);
				}, obj )));
			}, {})
	};

	Object.defineProperties( PluginManager.prototype, prototypeAccessors$2 );

	function toggleBlockType (type, toggletype, attrs) {
		if ( attrs === void 0 ) attrs = {};

		return function (state, dispatch, view) {
			var isActive = nodeIsActive(state, type, attrs);

			if (isActive) {
				return prosemirrorCommands.setBlockType(toggletype)(state, dispatch, view)
			}

			return prosemirrorCommands.setBlockType(type, attrs)(state, dispatch, view)
		}
	}

	function toggleList$$1(type, itemType) {
	  return function (state, dispatch, view) {
	    var isActive = nodeIsActive(state, type);

	    if (isActive) {
	      return prosemirrorSchemaList.liftListItem(itemType)(state, dispatch, view)
	    }

	    return prosemirrorSchemaList.wrapInList(type)(state, dispatch, view)
	  }
	}

	// https://discuss.prosemirror.net/t/list-type-toggle/948

	// import { wrapInList, liftListItem } from 'prosemirror-schema-list'

	// function isList(node, schema) {
	//   return (node.type === schema.nodes.bullet_list || node.type === schema.nodes.ordered_list)
	// }

	// export default function toggleList(listType, schema) {
	//   const lift = liftListItem(schema.nodes.list_item)
	// 	const wrap = wrapInList(listType)

	//   return (state, dispatch) => {
	//     const { $from, $to } = state.selection
	//     const range = $from.blockRange($to)
	//     if (!range) {
	//       return false
	// 		}

	//     if (range.depth >= 2 && $from.node(range.depth - 1).type === listType) {
	//       return lift(state, dispatch)
	//     } else if (range.depth >= 2 && isList($from.node(range.depth - 1), schema)) {
	//       const tr = state.tr
	// 			const node = $from.before(range.depth - 1)
	// 			console.log({node})
	//       // TODO: how do I pass the node above to `setNodeType`?
	//       // tr.setNodeType(range.start, listType);
	//       if (dispatch) dispatch(tr)
	//       return false
	//     } else {
	//       return wrap(state, dispatch)
	//     }
	//   }
	// }

	function updateMark (type, attrs) {
	  return function (state, dispatch) {
			var ref = state.selection;
			var from = ref.from;
			var to = ref.to;
			return dispatch(state.tr.addMark(from, to, type.create(attrs)))
		}
	}

	exports.chainCommands = prosemirrorCommands.chainCommands;
	exports.deleteSelection = prosemirrorCommands.deleteSelection;
	exports.joinBackward = prosemirrorCommands.joinBackward;
	exports.selectNodeBackward = prosemirrorCommands.selectNodeBackward;
	exports.joinForward = prosemirrorCommands.joinForward;
	exports.selectNodeForward = prosemirrorCommands.selectNodeForward;
	exports.joinUp = prosemirrorCommands.joinUp;
	exports.joinDown = prosemirrorCommands.joinDown;
	exports.lift = prosemirrorCommands.lift;
	exports.newlineInCode = prosemirrorCommands.newlineInCode;
	exports.exitCode = prosemirrorCommands.exitCode;
	exports.createParagraphNear = prosemirrorCommands.createParagraphNear;
	exports.liftEmptyBlock = prosemirrorCommands.liftEmptyBlock;
	exports.splitBlock = prosemirrorCommands.splitBlock;
	exports.splitBlockKeepMarks = prosemirrorCommands.splitBlockKeepMarks;
	exports.selectParentNode = prosemirrorCommands.selectParentNode;
	exports.selectAll = prosemirrorCommands.selectAll;
	exports.wrapIn = prosemirrorCommands.wrapIn;
	exports.setBlockType = prosemirrorCommands.setBlockType;
	exports.toggleMark = prosemirrorCommands.toggleMark;
	exports.autoJoin = prosemirrorCommands.autoJoin;
	exports.baseKeymap = prosemirrorCommands.baseKeymap;
	exports.pcBaseKeymap = prosemirrorCommands.pcBaseKeymap;
	exports.macBaseKeymap = prosemirrorCommands.macBaseKeymap;
	exports.wrappingInputRule = prosemirrorInputrules.wrappingInputRule;
	exports.textblockTypeInputRule = prosemirrorInputrules.textblockTypeInputRule;
	exports.addListNodes = prosemirrorSchemaList.addListNodes;
	exports.wrapInList = prosemirrorSchemaList.wrapInList;
	exports.splitListItem = prosemirrorSchemaList.splitListItem;
	exports.liftListItem = prosemirrorSchemaList.liftListItem;
	exports.sinkListItem = prosemirrorSchemaList.sinkListItem;
	exports.removeMark = removeMark;
	exports.toggleBlockType = toggleBlockType;
	exports.toggleList = toggleList$$1;
	exports.updateMark = updateMark;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
